#include "fxlib.h"
#include "menu.h"
#include "spritesandmaps.h"
#include "jugar.h"
#include "math.h"

const double PI=3.141592654;

void jugar(joueur* jugador, int nombrejoueurs, int planetas, gravedad* Gravedad)
{int i;
int n;
int muertos;
	while(IsKeyDown(KEY_CTRL_EXE)) {}

	do 
	{muertos=0;
		for(i=0; i<nombrejoueurs; i++)
		{desplazarse(i, jugador);
		apuntar(i, jugador, planetas, Gravedad, nombrejoueurs);

		for(n=1; n<nombrejoueurs; n++)
		{
			if(jugador[n].vida>0) {cargar_lombriz(jugador[n].x, jugador[n].y);}
			if(jugador[n].vida<=0) {muertos++;}
		}

		}

	} while (muertos>=(nombrejoueurs-1));
}

void desplazarse(int i, joueur*jugador)
{int a;
int Xinit=jugador[i].x;
int Yinit=jugador[i].y;

	do
	{GetKeyWait(KEYWAIT_HALTON_TIMEROFF, 0, 0, &a);

		if(a==KEY_CHAR_8 && jugador[i].y>1 && ML_pixel_test(jugador[i].x, jugador[i].y-4)!=1 && sqrt((Xinit-jugador[i].x)*(Xinit-jugador[i].x)+(Yinit-jugador[i].y)*(Yinit-jugador[i].y))<100)
		{borrar_lombriz(jugador[i].x, jugador[i].y);
		jugador[i].y--;
		cargar_lombriz(jugador[i].x, jugador[i].y);}

		if(a==KEY_CHAR_2 && jugador[i].y<64 && ML_pixel_test(jugador[i].x, jugador[i].y+4)!=1 && sqrt((Xinit-jugador[i].x)*(Xinit-jugador[i].x)+(Yinit-jugador[i].y)*(Yinit-jugador[i].y))<100)
		{borrar_lombriz(jugador[i].x, jugador[i].y);
		jugador[i].y++;
		cargar_lombriz(jugador[i].x, jugador[i].y);}

		if(a==KEY_CHAR_6 && jugador[i].x<128 && ML_pixel_test(jugador[i].x+4, jugador[i].y)!=1 && sqrt((Xinit-jugador[i].x)*(Xinit-jugador[i].x)+(Yinit-jugador[i].y)*(Yinit-jugador[i].y))<100)
		{borrar_lombriz(jugador[i].x, jugador[i].y);
		jugador[i].x++;
		cargar_lombriz(jugador[i].x, jugador[i].y);}

		if(a==KEY_CHAR_4 && jugador[i].x>1 && ML_pixel_test(jugador[i].x-4, jugador[i].y)!=1 && sqrt((Xinit-jugador[i].x)*(Xinit-jugador[i].x)+(Yinit-jugador[i].y)*(Yinit-jugador[i].y))<100)
		{borrar_lombriz(jugador[i].x, jugador[i].y);
		jugador[i].x--;
		cargar_lombriz(jugador[i].x, jugador[i].y);}

	ML_display_vram();} while (IsKeyUp(KEY_CTRL_EXE));

	while(IsKeyDown(KEY_CTRL_EXE)) {}

}

void apuntar(int i, joueur* jugador, int planetas, gravedad* Gravedad, int nombrejoueurs)
{int a;
int angulo=0;
double potencia=1;

	do
	{GetKeyWait(KEYWAIT_HALTON_TIMEROFF, 0, 0, &a);

		if(a==KEY_CHAR_8)
		{angulo=(angulo+1)%360;}

		if(a==KEY_CHAR_2)
		{angulo=(angulo-1)%360;}

		if(a==KEY_CHAR_6 && potencia<5)
		{potencia+=0.5;}

		if(a==KEY_CHAR_4 && potencia>1)
		{potencia-=0.5;}

	ML_lineDD(jugador[i].x, jugador[i].y, ceil((potencia+1)*cos(angulo*PI/180)), ceil((potencia+1)*sin(angulo*PI/180)), 0);
	ML_display_vram();
	ML_lineDD(jugador[i].x, jugador[i].y, ceil((potencia+1)*cos(angulo*PI/180)), ceil((potencia+1)*sin(angulo*PI/180)), 1);
	}while(IsKeyUp(KEY_CTRL_EXE));

	while (IsKeyDown(KEY_CTRL_EXE)) {}

trayectoria(i, jugador, angulo, potencia, planetas, Gravedad, nombrejoueurs);

}

void trayectoria(int i, joueur* jugador, int angulo, double potencia, int planetas, gravedad* Gravedad, int nombrejoueurs)
{double vector_x=potencia*cos(angulo*PI/180), vector_y=potencia*sin(angulo*PI/180), vector_x2=0, vector_y2=0, norma2=0;
int x=jugador[i].x, y=jugador[i].y, n;

	do
	{
		for(n=0; n<planetas; n++)
		{
			if(x!=jugador[i].x && y!=jugador[i].y) {ML_rectangle(x-1, y-1, x+1, y+1, 1, 1, 1);}
		vector_x2=Gravedad[n].x-x;
		vector_y2=Gravedad[n].y-y;
		norma2=sqrt((vector_x2*vector_x2)+(vector_y2*vector_y2));

			if(norma2<=15)
			{vector_x2/=norma2;
			vector_y2/=norma2;
			norma2=64/(norma2*norma2);
			vector_x2*=norma2;
			vector_y2*=norma2;
			vector_x+=vector_x2;
			vector_y+=vector_y2;
			}
		x+=vector_x;
		y+=vector_y;

		}

		if(x!=jugador[i].x && y!=jugador[i].y) {ML_rectangle(x-1, y-1, x+1, y+1, 1, 0, 0);}
ML_display_vram();
	
	}while((IsKeyUp(KEY_CTRL_EXE) && x>1 && x<128 && y>1 && y<64 && !(ML_pixel_test(x, y))) || sqrt((x-jugador[i].x)*(x-jugador[i].x)+(y-jugador[i].y)*(y-jugador[i].y)<3));

	if(x>=1 && x<=128 && y>=1 && y<=64) {explotar(jugador, x, y, nombrejoueurs);}

}

void explotar(joueur* jugador, int  x, int y, int nombrejoueurs)
{int i;
double distancia;
	for(i=0; i<nombrejoueurs; i++)
	{
	distancia=sqrt((x-jugador[i].x)*(x-jugador[i].x)+(y-jugador[i].y)*(y-jugador[i].y));

		if(distancia<=5)
		{jugador[i].vida-=100/distancia;}

		if(jugador[i].vida<=0)
		{borrar_lombriz(jugador[i].x, jugador[i].y);}

	}

	for(i=1; i<=5; i++)
	{ML_filled_circle(x, y, i, 1);
	}

ML_filled_circle(x, y, 5, 0);

}